PRITE ?= libresprite
TILED ?= tiled
ZIP ?= zip

tilesets := $(patsubst src/res/set/%.ase,out/%.png,$(wildcard src/res/set/*.ase))
images := $(patsubst src/res/%.ase,out/%.png,$(wildcard src/res/*.ase))
maps := $(patsubst src/res/%.tmx,out/%.map,$(wildcard src/res/*.tmx))
music := $(wildcard src/res/*.xm)
collision := $(wildcard src/res/*.col)

out/%.png: src/res/%.ase | out/
	${PRITE} -b $(abspath $<) --save-as $(abspath $@)

out/set.%.png: src/res/set/%.ase | out/
	${PRITE} -b $(abspath $<) --save-as $(abspath $@)

out/%.png: out/set.%.png | out/rearrange
	out/rearrange $@ $<

out/%.json: src/res/%.tmx ${tilesets} ${images} | out/
	${TILED} $< --export-map $@ --embed-tilesets

out/%.map: out/%.json out/json2map | out/
	out/json2map $< $@

out/assets.res: ${tilesets} ${images} ${maps} ${music} ${collision} | out/
	${ZIP} -Xj9q $@ $?
