#/bin/sh

case $1 in
	gnu-linux)
		NS=gl EXTENSION=x86_64 CFLAGS='-g1 -Os' make
		;;
	ms-windows)
		NS=w EXTENSION=exe CFLAGS='-g1 -Os -mwindows' CC='x86_64-w64-mingw32-cc' make
		;;
	leak)
		NS=leak CFLAGS='-g -Og -fsanitize=leak -llsan' make
		;;
	ub)
		NS=ub CFLAGS='-g -Og -fsanitize=undefined -lubsan' make
		;;
	emscripten)
		NS=em EXTENSION=html CC='/usr/lib/emscripten/emcc' CFLAGS='-g2 -O1 -sUSE_SDL=2 -sUSE_ZLIB' LDFLAGS='-sASYNCIFY --embed-file out/assets.res@./assets.res' make
		;;
	*)
		echo >&2 "dont know how to build '$1'"
		exit 1
esac
